#ifndef CONFIG_H
#define CONFIG_H

/*
  The dictionary is stored as 16 bit ints, so endianess matters.
*/
#define USE_LITTLE_ENDIAN

/*
 Note: A CELL is 2 bytes.
*/

/* 
   FLASH
*/
/* #define MAX_DICT_CELLS 		4096 /* 8192 bytes */
#define MAX_DICT_CELLS 		1024 /* 2048 bytes */

#ifdef RAM_DICT
# define CONST
#else
# define CONST const
#endif

/*
  RAM
*/
#define DS_CELLS 		20
#define RS_CELLS 		50
#define URAM_CELLS		20


/*
 All dictionary writing/updating is captured here.
 If using RAM, then the below macros are probably all you need.
 If using ROM/Flash, then you should either replace with your
 own functions.
*/
#ifdef RAM_DICT
# define dict_set_last_word(cell) dict->last_word_idx=cell
# define dict_incr_here(n) dict->here += n
# define dict_append(cell) dict->d[dict->here] = cell, dict_incr_here(1)
# define dict_write(idx,cell) dict->d[idx] = cell
# define dict_append_string(src,len) { \
    strncpy((char*)((dict->d)+(dict->here)),src,len);			\
    dict->here += (str_len/BYTES_PER_CELL) + (str_len % BYTES_PER_CELL); \
}
#else
# define dict_set_last_word(cell)
# define dict_incr_here(n)
# define dict_append(cell)
# define dict_write(idx,cell)
# define dict_append_string(src,len)

#endif	/* RAM_DICT */

#endif	/* CONFIG_H */
